<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class prove extends CI_Controller {

	function index()
	{
		$this->load->model('prove_model');
		
		$log = $this->prove_model->get_mode();
		$this->load->view('prove/common', array('log'=>$log));
	}


	// Get & set curent prove mode
	function mode()
	{
		$this->load->model('prove_model');
		!empty($this->uri->segments[3]) ? $mode = $this->uri->segments[3] : $mode = NULL;
		$result = $this->prove_model->mode($mode);
		$this->load->view('prove/common', array('data'=>array('result'=>$result,'mode'=>$mode)));
	}


	// Get php source
	function php_source()
	{
		$this->load->model('prove_model');
		$file = @$_GET['file'];
		$src = $this->prove_model->get_php_source($file);
		$this->load->view('prove/php_source', array('src'=>$src, 'path'=>$file));
	}


	// Download any file
	function download_file()
	{
		$this->load->model('prove_model');
		$file = @$_GET['file'];
		$data = $this->prove_model->get_file($file);
		$this->load->view('prove/download', array('data'=>$data, 'path'=>$file));
	}


	// Save activation key
	function activate_license()
	{
		if (is_writable(ini_get('prove.activation_key_file'))) {
			if (prove_activate_license()) {
				$resp = ini_get('prove.activation_key_file').' へ アクティベーションキー を保存しました。';
			} else {
				$resp = ini_get('prove.activation_key_file').' へ アクティベーションキー　を保存できませんでした。アクセス権限、PHPのエラーログを確認してください。';
			}
		} else {
			$resp = ini_get('prove.activation_key_file').'に書き込み権限がありません。権限を確認してください。';
		}
		$this->load->view('prove/activate_license', array('resp'=>$resp));
	}


	///////////////////////////////////////////////////////////////////////////////
	// Get specific log
	function trace_request()
	{
		$this->load->model('prove_model');
		$id = @$_GET['id'];
		$log = @$this->prove_model->get_trace_request($id);
		$this->load->view('prove/json', array('data'=>$log));
	}


	// Get mime type of specific log
	function trace_request_mime()
	{
		$this->load->model('prove_model');
		$id = @$_GET['id'];
		$log = @$this->prove_model->get_trace_request_output($id);
		$this->load->view('prove/mime', array('data'=>$log));
	}


	// Get specified logs
	function trace_requests()
	{
		$this->load->model('prove_model');
		$page = @$_GET['page'];
		$rows = @$_GET['rows'];
		$sidx = @$_GET['sidx'];
		$sord = @$_GET['sord'];
		$log = $this->prove_model->get_trace_requests($page, $rows, $sidx, $sord);
		$this->load->view('prove/json', array('data'=>$log));
	}


	// Get number of logs
	function trace_num_logs()
	{
		$this->load->model('prove_model');
		$obj = new StdClass;
		$obj->num = (int)@$this->prove_model->get_trace_num_logs($id);
		$this->load->view('prove/json', array('data'=>$obj));
	}


	// Get output trace
	function trace_output_text()
	{
		$this->load->model('prove_model');
		$id = @$_GET['id'];
		$trace = @$this->prove_model->get_trace_output_text($id);
		$this->load->view('prove/trace_text', array('data'=>$trace, 'tab_name'=>'Trace OUTPUT'));
	}


	// Get other trace
	function trace_internal_text()
	{
		$this->load->model('prove_model');
		$id = @$_GET['id'];
		$use_var_export = isset($_GET['use_var_export']);
		$trace = @$this->prove_model->get_trace_internal_text($id, $use_var_export);
		$use_var_export ? $name = 'Trace INTERNAL (var_export)' : $name = 'Trace INTERNAL (serialize)';
		$this->load->view('prove/trace_text', array('data'=>$trace, 'tab_name'=>$name));
	}


	// Get other trace
	function trace_internal_array()
	{
		$this->load->model('prove_model');
		$id = @$_GET['id'];
		$trace = @$this->prove_model->get_trace_internal_array($id);
		$this->load->view('prove/trace_array', array('data'=>$trace));
	}


	///////////////////////////////////////////////////////////////////////////////
	// Get specific log
	function validate_request()
	{
		$this->load->model('prove_model');
		$id = @$_GET['id'];
		$log = @$this->prove_model->get_validate_request($id);
		$this->load->view('prove/json', array('data'=>$log));
	}


	// Get mime type of specific log
	function validate_request_mime()
	{
		$this->load->model('prove_model');
		$id = @$_GET['id'];
		$log = @$this->prove_model->get_validate_request_output($id);
		$this->load->view('prove/mime', array('data'=>$log));
	}


	// Get specified logs 
	function validate_requests()
	{
		$this->load->model('prove_model');
		$page = @$_GET['page'];
		$rows = @$_GET['rows'];
		$sidx = @$_GET['sidx'];
		$sord = @$_GET['sord'];
		$log = $this->prove_model->get_validate_requests($page, $rows, $sidx, $sord);
		$this->load->view('prove/json', array('data'=>$log));
	}


	// Get number of logs
	function validate_num_logs()
	{
		$this->load->model('prove_model');
		$obj = new StdClass;
		$obj->num = (int)@$this->prove_model->get_validate_num_logs($id);
		$this->load->view('prove/json', array('data'=>$obj));
	}


	// Get output validate
	function validate_output_text()
	{
		$this->load->model('prove_model');
		$id = @$_GET['id'];
		$validate = @$this->prove_model->get_validate_output_text($id);
		$this->load->view('prove/validate_text', array('data'=>$validate, 'tab_name'=>'Validate OUTPUT'));
	}


	// Get other validate
	function validate_internal_text()
	{
		$this->load->model('prove_model');
		$id = @$_GET['id'];
		$use_var_export = isset($_GET['use_var_export']);
		$validate = @$this->prove_model->get_validate_internal_text($id, $use_var_export);
		$use_var_export ? $name = 'Validate INTERNAL (var_export)' : $name = 'Validate INTERNAL (serialize)';
		$this->load->view('prove/validate_text', array('data'=>$validate, 'tab_name'=>$name));
	}


	// Get other validate
	function validate_internal_array()
	{
		$this->load->model('prove_model');
		$id = @$_GET['id'];
		$validate = @$this->prove_model->get_validate_internal_array($id);
		$this->load->view('prove/validate_array', array('data'=>$validate));
	}


	///////////////////////////////////////////////////////////////////////////////
	// Get specific log
	function diff_request()
	{
		$this->load->model('prove_model');
		$id = @$_GET['id'];
		$log = @$this->prove_model->get_diff_request($id);
		$this->load->view('prove/json', array('data'=>$log));
	}


	// Get mime type of specific log
	function diff_request_mime()
	{
		$this->load->model('prove_model');
		$id = @$_GET['id'];
		$log = @$this->prove_model->get_diff_request_output($id);
		$this->load->view('prove/mime', array('data'=>$log));
	}


	// Get specified logs
	function diff_requests()
	{
		$this->load->model('prove_model');
		$page = @$_GET['page'];
		$rows = @$_GET['rows'];
		$sidx = @$_GET['sidx'];
		$sord = @$_GET['sord'];
		$log = $this->prove_model->get_diff_requests($page, $rows, $sidx, $sord);
		$this->load->view('prove/json', array('data'=>$log));
	}


	// Get number of logs
	function diff_num_logs()
	{
		$this->load->model('prove_model');
		$obj = new StdClass;
		$obj->num = (int)@$this->prove_model->get_diff_num_logs($id);
		$this->load->view('prove/json', array('data'=>$obj));
	}


	// Get output diff
	function diff_output_text()
	{
		$this->load->model('prove_model');
		$id = @$_GET['id'];
		$use_var_export = (bool)@$_GET['use_var_export'];
		$diff = @$this->prove_model->get_diff_output_text($id, $use_var_export);
		$this->load->view('prove/diff_text', array('data'=>$diff, 'tab_name'=>'OUTPUT Difference', 'request_id'=>$id, 'use_var_export'=>$use_var_export, 'output'=>true));
	}


	// Get other diff
	function diff_internal_text()
	{
		$this->load->model('prove_model');
		$id = @$_GET['id'];
		$use_var_export = (bool)@($_GET['use_var_export']);
		$output = (bool)@$_GET['output'];
		// FIXME: This may cause crash with large data
		$diff = @$this->prove_model->get_diff_internal_text($id, $use_var_export);
		$use_var_export ? $name = 'INTERNAL (var_export) Differenece' : $name = 'INTERNAL (serialize) Difference';
		$this->load->view('prove/diff_text', array('data'=>$diff, 'tab_name'=>$name, 'request_id'=>$id, 'use_var_export'=>$use_var_export, 'output'=>$output));
	}


	// Get other diff
	function diff_internal_array()
	{
		$this->load->model('prove_model');
		$id = @$_GET['id'];
		$diff = @$this->prove_model->get_diff_internal_array($id);
		$this->load->view('prove/diff_array', array('data'=>$diff));
	}


	// Get diff source file
	function get_diff_internal_text_src_validate() {
		$this->load->model('prove_model');
		$id = @$_GET['id'];
		$use_var_export = (bool)@$_GET['use_var_export'];
		$output = (bool)@$_GET['output'];
		$text = $this->prove_model->get_diff_internal_text_src_validate($id, $use_var_export, $output);
		$this->load->view('prove/plain_text', array('id'=>$id, 'use_var_export'=>$use_var_export, 'text'=>$text));
	}


	// Get diff source file
	function get_diff_internal_text_src_diff() {
		$this->load->model('prove_model');
		$id = @$_GET['id'];
		$use_var_export = (bool)@$_GET['use_var_export'];
		$output = (bool)@$_GET['output'];
		$text = $this->prove_model->get_diff_internal_text_src_diff($id, $use_var_export, $output);
		$this->load->view('prove/plain_text', array('id'=>$id, 'use_var_export'=>$use_var_export, 'text'=>$text));
	}
}