<?php

class config_model extends CI_Model {
	public $config = NULL;
	public $config_path = NULL;


	// Check config
	private $config_attr = array(
			'php.ini' => 'file',
			'php.exe' => 'file',
			'php.error' => 'file',
			'web.error' => 'file',
			'web.access' => 'file',
			'prove_client' => 'file',
			'prove_client.opts' => 'string',
			'prove_client.conf' => 'config',  //Should not check this
			'prove_client.pid' => 'file',     //prove_client must be edited to change this
			'prove_client.out' => 'file'
			);


	function __construct()
	{
		// Call the Model constructor
		parent::__construct();
		$this->get();
	}


	function get_config_form_data()
	{
		$config = $this->config;

		$data['php.ini'] = array(
			'name' => 'php_ini',
			'id' => 'php_ini',
			'value' => $config['php.ini'],
			'maxlength' => '100',
			'size' => '50',
			);
		$data['php.exe'] = array(
			'name' => 'php_exe',
			'id' => 'php_exe',
			'value' => $config['php.exe'],
			'maxlength' => '100',
			'size' => '50',
			);
		$data['php.error'] = array(
			'name' => 'php_error',
			'id' => 'php_error',
			'value' => $config['php.error'],
			'maxlength' => '100',
			'size' => '50',
			);
		$data['web.error'] = array(
			'name' => 'web_error',
			'id' => 'web_error',
			'value' => $config['web.error'],
			'maxlength' => '100',
			'size' => '50',
			);
		$data['web.access'] = array(
			'name' => 'web_access',
			'id' => 'web_access',
			'value' => $config['web.access'],
			'maxlength' => '100',
			'size' => '50',
			);
		$data['prove_client'] = array(
			'name' => 'prove_client',
			'id' => 'prove_client',
			'value' => $config['prove_client'],
			'maxlength' => '100',
			'size' => '50',
			);
		$data['prove_client.conf'] = array(
			'name' => 'prove_client.conf',
			'id' => 'prove_client.conf',
			'value' => $config['prove_client.conf'],
			'maxlength' => '100',
			'size' => '50',
			);
		$data['prove_client.opts'] = array(
			'name' => 'prove_client.opts',
			'id' => 'prove_client.opts',
			'value' => $config['prove_client.opts'],
			'maxlength' => '100',
			'size' => '50',
			);
		$data['prove_client.pid'] = array(
			'name' => 'prove_client.pid',
			'id' => 'prove_client.pid',
			'value' => $config['prove_client.pid'],
			'maxlength' => '100',
			'size' => '50',
			);
		$data['prove_client.out'] = array(
			'name' => 'prove_client.out',
			'id' => 'prove_client.out',
			'value' => $config['prove_client.out'],
			'maxlength' => '100',
			'size' => '50',
			);

		$data['submit_btn'] = array(
			'type' => 'submit',
			'name' => 'submit_btn',
			'id' => 'submit_btn',
			'value' => '送信',
			);

		return $data;
	}


	function get()
	{
		if (strpos(PHP_OS, 'Win')) {
			$config_pathes = array(
				'c:/prove/prove_client.conf',
				);
		} else {
			$config_pathes = array(
				'/etc/prove_client.conf',
				'/tmp/prove_client.conf',
				'/prove/prove_client.conf',
				);
		}
		foreach($config_pathes as $path) {
			@include($path);
			if (!empty($config) && is_array($config)) {
				$this->config = $config;
				$this->config['prove_client.conf'] = $path;
				return $config;
			}
		}

		// No config. Return defaults
		if (strpos(PHP_OS, 'Win')) {
			$config = array(
				'php.ini' => 'c:/php/php.ini',
				'php.exe' => 'c:/php/php.exe',
				'php.error' => 'c:/php/php_error.log',
				'web.error' => 'c:/apache/logs/error_log',
				'web.access' => 'c:/apache/logs/access_log',
				'prove_client' => 'c:/prove-tools/prove_client',
				'prove_client.conf' => '',
				'prove_client.opts' => '',
				'prove_client.pid' => 'c:/tmp/prove_client.pid',
				'prove_client.out' => 'c:/tmp/prove_client.out',
				);
		} else {
			$config = array(
				'php.ini' => '/etc/php.ini',
				'php.exe' => '/usr/bin/php',
				'php.error' => '/tmp/php_error.log',
				'web.error' => '/var/log/httpd/error_log',
				'web.access' => '/var/log/httpd/access_log',
				'prove_client' => '/usr/libexec/prove/prove_client',
				'prove_client.conf' => '',
				'prove_client.opts' => '',
				'prove_client.pid' => '/tmp/prove_client.pid',
				'prove_client.out' => '/tmp/prove_client.out',
			);
		}
		$this->config_path = NULL;
		$this->config = $config;
		return $config;
	}


	function save()
	{
		$error = array();
		if (!$this->config) {
			$this->get();
		}
		if (!$this->config['prove_client.conf']) {
			// Default save path
			$this->config['prove_client.conf'] = '/tmp/prove_client.conf';
		}
		// Decode JSON data
		parse_str($_POST['params'], $data);
		$config_attr = $this->config_attr;
		// Remove unneeded element
		unset($config_attr['prove_client.pid']);
		unset($config_attr['prove_client.conf']);
		foreach($config_attr as $k => $v) {
			$kk = strtr($k,'.','_');
			$this->config[$k] = isset($data[$kk]) ? $data[$kk] : '';
			if (!isset($this->config[$k])) {
				$error[] = $k.'設定が在りません。';
				continue;
			}
			if ($v == 'file' && !@is_file($this->config[$k])) {
				$error[] = $k.'ファイルが存在しません。('.$this->config[$k].')';
				continue;
			}
			if ($v == 'dir' && !@is_dir($this->config[$k])) {
				$error[] = $k.'ディレクトリが存在しません。('.$this->config[$k].')';
				continue;
			}
		}
		// Write config to file
		$config_str = '<?php $config = '.PHP_EOL. var_export($this->config, true). ';';
		if (!@file_put_contents($this->config['prove_client.conf'], $config_str)) {
			$error[] = '設定ファイルの書き込みに失敗しました。('.$this->config['prove_client.conf'].')　Webサーバに書き込み権限があるか確認してください。';
		} else {
			$error[] = '設定ファイルを書き込みました。('.$this->config['prove_client.conf'].')';
		}
		return $error;
	}


	// Check current PROVE config
	function check()
	{
		$error = array();
		if (!$this->config) {
			$this->get();
		}
		//var_dump($this->config);die();
		$config_attr = $this->config_attr;
		foreach($config_attr as $k => $v) {
			if (!isset($this->config[$k])) {
				$error[] = $k.'設定が在りません。';
				continue;
			}
			if ($v == 'file' && !@is_file($this->config[$k])) {
				$error[] = $k.'ファイルが存在しません。('.$this->config[$k].')';
				continue;
			}
			if ($v == 'dir' && !@is_dir($this->config[$k])) {
				$error[] = $k.'ディレクトリが存在しません。('.$this->config[$k].')';
				continue;
			}
		}
		return $error;
	}


	// Check system config and environment
	function check_env()
	{
		$info = prove_info();
		$errors = array();

		// Zend Extension
		if ($info['extension'] != 'Zend Extension') {
			$errors[] = 'PROVEがZendモジュールとしてロードされていません。ZendモジュールとしてロードしないとPROVEは利用できません。php.iniを確認してWebサーバを再起動してください。';
		}
		// Activation
		if ($info['activation'] != 'Valid') {
			$errors[] = 'アクティベーションキーが無効です。PROVEをご利用頂くにはアクティベーションがキーが必要です。アクティベーションタブからキーを取得してしてください。アクティベーションはライセンス・ホスト情報を送信するだけで完了します。';
		}
		// license
		if ($info['license'] != 'Valid') {
			$errors[] = 'ライセンスが無効です。新しいライセンスを取得するかphp.iniのライセンス情報を確認してください。非営利の個人利用であればWebサイトから無償ライセンスを取得できます。商用ライセンスユーザの方はPROVEパートナーにご相談ください。';
		} else {
			$expire = strtotime($info['license_expire']);
			$now    = strtotime(date('Y/m/d'));
			$diff   = (int)(($expire-$now)/60/60/24);

			if ($diff < 30) {
				$errors[] = 'ライセンスが失効まで'.$diff.'日です。ライセンス失効日：'.$info['license_expire'].'非営利の個人利用であればWebサイトから無償ライセンスを取得できます。商用ライセンスユーザの方はPROVEパートナーにご相談ください。';
			}
		}

		// license type
		if ($info['license_type'] == 'FREE') {
			$errors[] = '非営利の個人利用および評価目的で利用できる無償ライセンス('.$info['license_type'].')です。商用利用の場合はライセンスを取得してください。';
		}
		// prove.mode_file
		@touch($info['mode_file']); // ignore errors
		if (!is_writable($info['mode_file'])) {
			$errors[] = 'PROVEのモードファイル「'.$info['mode_file'].'」 に書き込みできできません。Webサーバが「'.$info['mode_file'].'」に書き込み権限があるか確認してください。SELinuxの状態も確認してください。';
		}
		// prove.prove_dir
		if (!is_writable($info['prove_dir'])) {
			$errors[] = 'PROVEのログディレクトリ「'.$info['prove_dir'].'」 に書き込みできません。Webサーバが「'.$info['prove_dir'].'」に書き込み権限があるか確認してください。SELinuxの状態も確認してください。';
		}
		// prove dir
		$dir = $info['prove_dir'];
		if (!is_writable($dir)) {
			$errors[] = 'PROVEディレクトリ「'.$dir.'」 に書き込みできません。Webサーバが「'.$dir.'」に書き込み権限があるか確認してください。SELinuxの状態も確認してください。';
		}

		return $errors;
	}
}
