<!-- BEGIN status/system.php -->
<script type="text/javascript">
// Set currently selected log ID in undisplayed div
function set_current_log_id(id) {
    $("#current-log-id").text(id);
}

// Output helper that return "" null string for undefined/false
function out(data) {
    if (data) {
        return data;
    }
    return "";
}

// Write system status
function write_system_status(r) {
    $("#current-prove-mode").text(r.mode);
    $("#current-prove-mode-text").html(r.mode_str);
    $("#current-trace-lock-status").html(r.trace_lock_str);
    $("#client-status").html(r.client_status);
    if ($("#client-log").text() != r.client_log) {
        $("#client-log").text(r.client_log);
        $("#client-log").scrollTop(99999999);
        $("#client-log-cap").effect("highlight", {}, 1500, function() {});
    }
    $("#current-trace-log-id").text(out(r.trace_meta["id"]));
    if ($("#current-trace-log-count").text() != out(r.trace_meta["count"])) {
        $("#current-trace-log-count").text(out(r.trace_meta["count"])).effect("highlight", {}, 1500, function() {});
    } else {
        $("#current-trace-log-count").text(out(r.trace_meta["count"]));
    }
    $("#current-trace-log-name").text(out(r.trace_meta["name"]));
    $("#current-trace-log-desc").text(out(r.trace_meta["desc"]));
    if (r.trace_meta["locked"]) {
        $("#current-trace-log-locked").html("<strong>true</strong>");
    } else {
        $("#current-trace-log-locked").text("");
    }
    $("#current-trace-log-diff-id").text(out(r.trace_meta["diff_id"]));

    $("#current-validate-log-id").text(out(r.validate_log_id));
    $("#current-validate-log-count").text(out(r.validate_meta["count"]));
    $("#current-validate-log-name").text(out(r.validate_meta["name"]));
    $("#current-validate-log-desc").text(out(r.validate_meta["desc"]));
    if (r.validate_meta["locked"]) {
        $("#current-validate-log-locked").html("<strong>true</strong>");
    } else {
        $("#current-validate-log-locked").text("");
    }
    $("#current-validate-log-diff-id").text(out(r.validate_meta["diff_id"]));

    $("#current-diff-log-id").text(out(r.diff_log_id));
    if ($("#current-diff-log-count").text() != out(r.diff_meta["count"])) {
        $("#current-diff-log-count").text(out(r.diff_meta["count"])).effect("highlight", {}, 1500, function() {});
    } else {
        $("#current-diff-log-count").text(out(r.diff_meta["count"]));
    }
    $("#current-diff-log-name").text(out(r.diff_meta["name"]));
    $("#current-diff-log-desc").text(out(r.diff_meta["desc"]));
    if (r.diff_meta["locked"]) {
        $("#current-diff-log-locked").html("<strong>true</strong>");
    } else {
        $("#current-diff-log-locked").text("");
    }
    $("#current-diff-log-diff-id").text(out(r.diff_meta["diff_id"]));
}

// Update system status
function update_system_status() {
    $.get("<?php echo site_url('status/update')?>",
          null,
          function (r) {
              write_system_status(r);
          })
        .error(function() { $("#web-console-error").html('<span style="color:red">Update failed...</span>'); } )
        .success(function() {$("#web-console-error").html('Updating status'); } );
}


// Enable drag
function makeGridRowsDraggable() {
    var $searchResultsGrid  =   $("#prove-log-grid"),
    $searchResultsRows =    $("#prove-log-grid-container .ui-row-ltr");

    $searchResultsRows.css("cursor","move").draggable("destroy").draggable({
        revert:     "false",
        appendTo:   'body',
        cursor:     "move",
        cursorAt:   {
            top: 10,
            left: -5
        },
        helper:     function(event) {
            //get a hold of the row id
            var rowId = $(this).attr('id');

            //use the row id you found to get the column text; by using the getCell method as below, 
            //the 'unformatter' on that column is called; so, if value was formatted using a
            //formatter, this method will return the unformatted value 
            //(as long as you defined an unformatter/using a built-in formatter)
            var theValue = $searchResultsGrid.jqGrid('getCell', rowId, 'desiredValue');

            //set the data on this to the value to grab when you drop into input box
            $(this).data('colValue', theValue);
            return $("<div class='draggedValue ui-widget-header ui-corner-all'>" + theValue+ "</div>");
        },
        start:      function(event, ui) {
            //fade the grid
            $(this).parent().fadeTo('fast', 0.5);
                        },
        stop:       function(event, ui) {
            $(this).parent().fadeTo(0, 1);
        }
    });
}


// Make droppable
function createDroppableElement(elem) {
    $(elem).droppable({
        tolerance:  'pointer',
        hoverClass: 'active',
        activate:   function(event, ui) {
                        $(this).addClass("over");
                    },
        deactivate: function(event, ui) {
                        $(this).removeClass("over");
                    },

        drop:       function(event, ui) {
                        var theValue = ui.draggable.data('colValue');
                        theValue = theValue .replace(/<br>/gi,'; ');
                        console.log("dropped value: " + theValue );

                        updateText($(this), theValue);
                    }
    });
}


// Helper for createDroppableElement()
function updateText(txtTarget, theValue) {

    var currentValue = txtTarget.val().trim();

    if (currentValue.length > 0
        && currentValue.substr(currentValue.length-1) !== ";")
        currentValue = currentValue + '; ';

    currentValue += theValue;
    txtTarget.val(currentValue);
}


// Fluid Grid
function resize_prove_log_grid(myGrid) {
    $(myGrid).fluidGrid("100%");
}


$(document).ready(function() {
    // Update system status every 2.5 secounds
    $(document).ready(function() {
        $(document).everyTime(2500, function() {
            update_system_status();
        }, 0);
    });

    // Get num of logs in system
    $.get(
        "<?php echo site_url('/prove_log/num_logs') ?>",
        function(data) {
            $("#prove-num-logs").text(data.num);
        }
    );

    // Grid
    var myGrid = $("#prove-log-grid");
    myGrid.jqGrid({
        altRow: true,
        url: '<?php echo site_url("/prove_log/get_logs/"); ?>',
        datatype: "json",
        mtype: 'GET',
        colNames:['Log ID','Count', 'Log Name', 'Usage', 'Lock', 'Diff ID'],
        colModel:[
            {name:'id',index:'id', width:200},
            {name:'count',index:'count', width:70, align:'right'},
            {name:'name',index:'name', width:200},
            {name:'usage',index:'usage', width:200},
            {name:'locked',index:'locked', width:40},
            {name:'diff_id',index:'diff_id', width:200},
        ],
        jsonReader: {
            root: "rows",
            page: "page",
            total: "total",
            records: "records",
            cell: "cell",
            id: "id",
            repeatitems: false
        },
        hiddengrid: true,
        viewrecords: true,
        height: 200,
        multiselect: false,
        pager: $("#prove-log-grid-pager"),
        rowNum: 50,
        caption: "PROVE Logs",
        loadError : function(xhr,st,err) {
            jQuery("#rsperror").html("Type: "+st+"; Response: "+ xhr.status + " "+xhr.statusText); 
        },
        onSelectRow : function(rowid) {
            set_current_log_id(rowid);
        },
        loadComplete: function() {
            $("tr.jqgrow", this).contextMenu('log-menu', {
                bindings: {
                    'edit': function(trigger) {
                        // Check currently selected log ID
                        if (!$("#current-log-id").text()) {
                            alert("Please select log.");
                            return;
                        }
                        $.get(
                            "<?php echo site_url('/prove_log/log_meta') ?>",
                            {id:$("#current-log-id").text()},
                            function(r) {
                                //alert("Name:"+r.name+"  Desc:"+r.desc+"  Lock:"+r.locked+"  Diff ID:"+r.diff_id);
                                $("#edit-log-id-view").text($("#current-log-id").text());
                                $("#edit-log-id").val($("#current-log-id").text());
                                $("#edit-log-count").text(r.count);
                                $("#edit-log-name").val(r.name);
                                $("#edit-log-desc").val(r.desc);
                                r.locked ?
                                    $("#edit-log-locked").attr("checked", "checked") :
                                    $("#edit-log-locked").removeAttr("checked");
                                $("#edit-log-diff-id").val(r.diff_id);
                                $("#edit-log-dialog").dialog({width: 600, height: 300, autoResize: true});
                            }
                        );
                    },
                    'create': function(/*trigger*/) {
                        $("#create-log-dialog").dialog({width: 600, height: 200, autoResize: true});
                    },
                    'remove': function(trigger) {
                        // Check currently selected log ID
                        if (!$("#current-log-id").text()) {
                            alert("Please select log.");
                            return;
                        }
                        $("#remove-log-id").text($("#current-log-id").text());
                        // Get meta data
                        $.get("<?php echo site_url('prove_log/log_meta');?>",
                              {id:$("#current-log-id").text()},
                              function (r) {
                                  if (!r.id) {
                                      alert("Invalid log ID:" + $("#current-log-id").text());
                                      $("#remove-log-dialog").dialog("close");
                                  } else {
                                      // Set meta data
                                      $("#remove-log-name").text(r.name);
                                      $("#remove-log-desc").text(r.desc);
                                      $("#remove-log-locked").text(r.locked);
                                      $("#remove-log-diff-id").text(r.diff_id);
                                  }
                              });
                        $("#remove-log-dialog").dialog({width: 600, height: 300, autoResize: true});
                    },
                    "prepare-trace": function(trigger) {
                        if (!$("#current-prove-mode").text() != "0") {
                            alert("PROVE is working. Please disable PROVE.");
                            return;
                        }
                        if (!$("#current-log-id").text()) {
                            alert("Please select log.");
                            return;
                        }
                        // Check if it is used for validate or diff
                        if ($("#current-log-id").text() == $("#current-validate-log-id").text()
                            || $("#current-log-id").text() == $("#current-diff-log-id").text()) {
                            alert("This log is currently used as Validate or Diff");
                            return;
                        }
                        // Use this log
                        $.get("<?php echo site_url('prove_log/prepare_trace');?>",
                              {id:$("#current-log-id").text()},
                              function (r) {
                                  if (!r) {
                                      alert("Failed to prepare trace log");
                                  } else {
                                      alert("Trace Log is prepared");
                                  }
                              });
                    },
                    "prepare-validate": function(trigger) {
                        if (!$("#current-prove-mode").text() != "0") {
                            alert("PROVE is working. Please disable PROVE.");
                            return;
                        }
                        if (!$("#current-log-id").text()) {
                            alert("Please select log.");
                            return;
                        }
                        // Check if it is used for validate or diff
                        if ($("#current-log-id").text() == $("#current-trace-log-id").text()
                            || $("#current-log-id").text() == $("#current-diff-log-id").text()) {
                            alert("This log is currently used as Trace or Diff");
                            return;
                        }
                        // Use this log
                        $.get("<?php echo site_url('prove_log/prepare_validate');?>",
                              {id:$("#current-log-id").text()},
                              function (r) {
                                  if (!r) {
                                      alert("Failed to prepare validate log");
                                  } else {
                                      alert("Trace Log is prepared");
                                  }
                              });
                    },
                    "prepare-diff": function(trigger) {
                        if (!$("#current-prove-mode").text() != "0") {
                            alert("PROVE is working. Please disable PROVE.");
                            return;
                        }
                        if (!$("#current-log-id").text()) {
                            alert("Please select log.");
                            return;
                        }
                        // Check if it is used for validate or diff
                        if ($("#current-log-id").text() == $("#current-trace-log-id").text()
                            || $("#current-log-id").text() == $("#current-validate-log-id").text()) {
                            alert("This log is currently used as Trace or Validate");
                            return;
                        }
                        // Use this log
                        $.get("<?php echo site_url('prove_log/prepare_diff');?>",
                              {id:$("#current-log-id").text()},
                              function (r) {
                                  if (!r) {
                                      alert("Failed to prepare diff log");
                                  } else {
                                      alert("Trace Log is prepared");
                                  }
                              });
                    }
                }
            });
        }
    });

    jQuery("#prove-log-grid");
    resize_prove_log_grid("#prove-log-grid");
/*
    makeGridRowsDraggable();
    createDroppableElement("current-trace-log-id");
    createDroppableElement("current-validate-log-id");
    createDroppableElement("current-diff-log-id");
*/

    // Reload Grid when update button is clicked
    $("#update-grid").click(function(e) {
        $("#prove-log-grid").trigger("reloadGrid");
        update_system_status();
    });

    // Prepare trace for validation button
    $("#prepare-trace-data-for-validate").click(function(e) {
        e.preventDefault();
        $.get("<?php echo site_url('prove_log/prepare_validate');?>",
              {id:$("#current-trace-log-id").text()},
              function (r) {
                  if (!r) {
                      alert("Failed to prepare validation data.");
                  }
              });
        $("#prove-log-grid").trigger("reloadGrid");
        setTimeout('update_system_status()',500);
    });

    // Trace log archive button
    $("#save-trace-log").click(function(e) {
        e.preventDefault();
        if (!$("#current-trace-log-id").text()) {
            alert("No trace log.");
            return;
        }
        $.get("<?php echo site_url('prove_log/save_trace_log')?>",
              {},
              function(r) {
                  if (r) {
                      alert("Trace Log is archived.");
                  } else {
                      alert("Achive failed.");
                  }
              });
        $("#prove-log-grid").trigger("reloadGrid");
        update_system_status();
    });

    // Validate log archive button
    $("#save-validate-log").click(function(e) {
        e.preventDefault();
        if (!$("#current-validate-log-id").text()) {
            alert("No validate log.");
            return;
        }
        $.get("<?php echo site_url('prove_log/save_validate_log')?>",
              {},
              function(r) {
                  if (r) {
                      alert("Validate Log is archived.");
                  } else {
                      alert("Achive failed.");
                  }
              });
        $("#prove-log-grid").trigger("reloadGrid");
        update_system_status();
    });

    // Diff log archive button
    $("#save-diff-log").click(function(e) {
        e.preventDefault();
        if (!$("#current-diff-log-id").text()) {
            alert("No diff log.");
            return;
        }
        $.get("<?php echo site_url('prove_log/save_diff_log')?>",
              {},
              function(r) {
                  if (r) {
                      alert("Diff Log is archived.");
                  } else {
                      alert("Achive failed.");
                  }
              });
        $("#prove-log-grid").trigger("reloadGrid");
        update_system_status();
    });

    // Prove mode button
    $("#mode-disable").click(function(e) {
        e.preventDefault();
        $.get("<?php echo site_url('mode/disable');?>",
              {},
              function(r) {
                  if (!r) {
                      alert("Failed to disable PROVE.");
                  }
              });
        $("#prove-log-grid").trigger("reloadGrid");
        update_system_status();
    });

    $("#mode-trace").click(function(e) {
        e.preventDefault();
        $.get("<?php echo site_url('mode/trace')?>",
              {},
              function(r) {
                  if (!r) {
                      alert("Failed to switch trace mode.");
                  }
              });
        $("#prove-log-grid").trigger("reloadGrid");
        update_system_status();
    });

    $("#mode-validate").click(function(e) {
        e.preventDefault();
        $.get("<?php echo site_url('mode/validate')?>",
              {},
              function(r) {
                  if (!r) {
                      alert("Failed to switch validation mode.");
                  }
              });
        $("#prove-log-grid").trigger("reloadGrid");
        update_system_status();
    });


    // Edit log by clicking trace/validate/diff log ID
    $("#current-trace-log-id").click(function(e) {
        if ($("#current-trace-log-id").text() == "") {
            alert("トレースログがありません。"+$("#current-trace-log-id").text());
            return;
        }
        $.get("<?php echo site_url('/prove_log/log_meta') ?>",
              {id:$("#current-trace-log-id").text()},
              function(r) {
                  //alert("Name:"+r.name+"  Desc:"+r.desc+"  Lock:"+r.locked+"  Diff ID:"+r.diff_id);
                  $("#edit-log-id-view").text($("#current-trace-log-id").text());
                  $("#edit-log-id").val($("#current-trace-log-id").text());
                  $("#edit-log-count").text(r.count);
                  $("#edit-log-name").val(r.name);
                  $("#edit-log-desc").val(r.desc);
                  r.locked ?
                      $("#edit-log-locked").attr("checked", "checked") :
                      $("#edit-log-locked").removeAttr("checked");
                  $("#edit-log-diff-id").val(r.diff_id);
                  $("#edit-log-dialog").dialog({width: 600, height: 300, autoResize: true});
              });
        $("#prove-log-grid").trigger("reloadGrid");
        update_system_status();
    });
    $("#current-validate-log-id").click(function(e) {
        if (!$("current-validate-log-id")) {
            alert("バリデーションログがありません。");
        }
        e.preventDefault();
        $.get("<?php echo site_url('/prove_log/log_meta') ?>",
              {id:$("#current-validate-log-id").text()},
              function(r) {
                  //alert("Name:"+r.name+"  Desc:"+r.desc+"  Lock:"+r.locked+"  Diff ID:"+r.diff_id);
                  $("#edit-log-id-view").text($("#current-validate-log-id").text());
                  $("#edit-log-id").val($("#current-validate-log-id").text());
                  $("#edit-log-count").text(r.count);
                  $("#edit-log-name").val(r.name);
                  $("#edit-log-desc").val(r.desc);
                  r.locked ?
                      $("#edit-log-locked").attr("checked", "checked") :
                      $("#edit-log-locked").removeAttr("checked");
                  $("#edit-log-diff-id").val(r.diff_id);
                  $("#edit-log-dialog").dialog({width: 600, height: 300, autoResize: true});
              });
        $("#prove-log-grid").trigger("reloadGrid");
        update_system_status();
    });
    $("#current-diff-log-id").click(function(e) {
        if (!$("current-diff-log-id")) {
            alert("差分ログがありません。");
        }
        $.get("<?php echo site_url('/prove_log/log_meta') ?>",
              {id:$("#current-diff-log-id").text()},
              function(r) {
                  //alert("Name:"+r.name+"  Desc:"+r.desc+"  Lock:"+r.locked+"  Diff ID:"+r.diff_id);
                  $("#edit-log-id-view").text($("#current-diff-log-id").text());
                  $("#edit-log-id").val($("#current-diff-log-id").text());
                  $("#edit-log-count").text(r.count);
                  $("#edit-log-name").val(r.name);
                  $("#edit-log-desc").val(r.desc);
                  r.locked ?
                      $("#edit-log-locked").attr("checked", "checked") :
                      $("#edit-log-locked").removeAttr("checked");
                  $("#edit-log-diff-id").val(r.diff_id);
                  $("#edit-log-dialog").dialog({width: 600, height: 300, autoResize: true});
              });
        $("#prove-log-grid").trigger("reloadGrid");
        update_system_status();
    });


    // Remove by remove icon next to trace/validate/diff log ID
    $("#current-trace-log-id-remove").click(function (e) {
        if ($("#current-trace-log-id").text() == "") {
            alert("トレースログがありません。");
            return;
        }
        if (!window.confirm("トレースログを削除します。よろしいですか？")) {
            return;
        }
        $.get("<?php echo site_url('prove_log/remove');?>",
              {id:$("#current-trace-log-id").text()},
              function(r) {
                  if (r.id) {
                      //alert('Removed Log ID:'+r.id);
                  } else {
                      alert('Log remove failed.');
                  }
              });
        $("#prove-log-grid").trigger("reloadGrid");
        update_system_status();
    });
    $("#current-validate-log-id-remove").click(function (e) {
        if ($("#current-validate-log-id").text() == "") {
            alert("バリデーションログがありません。");
            return;
        }
        if (!window.confirm("バリデーションログを削除します。よろしいですか？")) {
            return;
        }
        $.get("<?php echo site_url('prove_log/remove');?>",
              {id:$("#current-validate-log-id").text()},
              function(r) {
                  if (r.id) {
                      //alert('Removed Log ID:'+r.id);
                  } else {
                      alert('Log remove failed.');
                  }
              });
        $("#prove-log-grid").trigger("reloadGrid");
        update_system_status();
    });
    $("#current-diff-log-id-remove").click(function (e) {
        if ($("#current-diff-log-id").text() == "") {
            alert("差分ログがありません。");
            return;
        }
        if (!window.confirm("差分ログを削除します。よろしいですか？")) {
            return;
        }
        $.get("<?php echo site_url('prove_log/remove');?>",
              {id:$("#current-diff-log-id").text()},
              function(r) {
                  if (r.id) {
                      //alert('Removed Log ID:'+r.id);
                  } else {
                      alert('Log remove failed.');
                  }
              });
        $("#prove-log-grid").trigger("reloadGrid");
        update_system_status();
    });


    // Validation(PROVE client) button
    $("#validate-start").click(function(e) {
        e.preventDefault();
        if ($("#current-trace-log-locked").text() == "true" || $("#current-diff-log-locked").text() == "true") {
            if (!window.confirm("トレースまたは差分ログがロックされています。実行するとロックが解除されます。ロックを無視してクライアントを実行しますか？")) {
                return;
            }
        }
        if ($("#current-prove-mode").text() != 2) {
            if (!window.confirm("動作モードがバリデーションではありません。クライアントを実行しますか？")) {
                return;
            }
        }
        $.get("<?php echo site_url('validate/start');?>",
              {},
              function (r) {
                  if (!r) {
                      alert("PROVEクライアントの実行に失敗しました。クライアント出力ファイルの権限・設定を確認して下さい。");
                  }
              });
        $("#prove-log-grid").trigger("reloadGrid");
        update_system_status();
    });


    $("#validate-stop").click(function(e) {
        e.preventDefault();
        $.get("<?php echo site_url('validate/stop');?>",
          {},
              function(r) {
                  if (!r) {
                      alert('PROVEクライアントの停止に失敗しました。');
                  }
              });
        $("#prove-log-grid").trigger("reloadGrid");
        update_system_status();
    });


    // Server shell dialog
    $("#web-shell-dialog").dialog({ autoOpen: false });
    $( "#web-shell" ).click(function(e) {
        e.preventDefault();
        $("#web-shell-dialog").dialog("open");
        $("#web-shell-dialog").dialog().dialog("option", "width", "80%").dialog( "option", "position", 'center' ).height("auto");
        $("#web-shell-dialog-content").html('<iframe src="<?php echo base_url().'/php-web-shell/client.php' ?>")" style="width: 100%; height: 450px"></iframe>');
    });


    // Context Menu forms
    $("#edit-log-form").submit(function(e) {
        e.preventDefault();
        $.get("<?php echo site_url('prove_log/edit');?>",
              $("#edit-log-form").serialize(),
              function(r) {
                  if (r.id) {
                      //alert('Log edited. Log ID:'+r.id);
                  } else {
                      alert('Log edit failed.');
                  }
                  $("#edit-log-dialog").dialog("close");
              });
        $("#prove-log-grid").trigger("reloadGrid");
        update_system_status();
    });

    $("#create-log-form").submit(function(e) {
        e.preventDefault();
        $.get("<?php echo site_url('prove_log/create');?>",
              $("#create-log-form").serialize(),
              function(r) {
                  if (r.id) {
                      //alert('Log created. Log ID:'+r.id);
                  } else {
                      alert('Log create failed.');
                  }
                  $("#create-log-dialog").dialog("close");
              });
        $("#prove-log-grid").trigger("reloadGrid");
        update_system_status();
    });

    $("#remove-log-form").submit(function(e) {
        e.preventDefault();
        $.get("<?php echo site_url('prove_log/remove');?>",
              {id:$("#current-log-id").text()},
              function(r) {
                  if (r.id) {
                      //alert('Removed Log ID:'+r.id);
                  } else {
                      alert('Log remove failed.');
                  }
                  $("#remove-log-dialog").dialog("close");
              });
        $("#prove-log-grid").trigger("reloadGrid");
        update_system_status();
    });

    // Make anchor button
    $( ".control-btn" ).button();

    // Make PROVE client log resizable
    $( "#client-log" ).resizable();

    // Hide error message
    $("#hide-error-message").click(function(e) {
        $("#error-message").hide();
        $.cookie("hide-error-message", 1)
    });
    if ($.cookie("hide-error-message") == 1) {
        $("#error-message").hide();
    }

    // Display content
    $("#prove-console").delay("100").toggle("fast");
});

</script>

<div onclick="$('#prove-console').toggle('slow')" class="mg_line02">
	<h3>PROVEの操作</h3>
</div>
<div class="mg_content" id="prove-console" style="display: none">
	<div class="mg_back">
		<div class="mg_header"></div>
		<table id="status-table">
			<thead>
				<?php if (!empty($info['errors'])): ?>
				<tr id="error-message">
					<td colspan="3">
						<div class="ui-widget">
							<div class="ui-state-error ui-corner-all" style="padding: 0 .7em;">
								<div style="width:100%;height:25px">
									<div style="float:left;width:250px;">
										<span class="ui-icon ui-icon-alert" style="float:left;margin-right:.3em;"></span>
										<strong>Alert:</strong> 構成に問題が見つかりました。
									</div>
									<div id="hide-error-message" style="float:right; width:150px;text-align:right;cursor:pointer">
										<strong>非表示</strong>
										<span class="ui-icon ui-icon-circle-close" style="float:right;margin-right:.3em;"></span>
									</div>
								</div>
								<ul>
									<?php
										 foreach($info['errors'] as $err) {
										 echo '<li>', h($err), '</li>', PHP_EOL;
										 }
										 ?>
								</ul>
							</div>
						</div>
					</td>
				</tr>
				<?php endif; ?>
				<tr>
					<th>&nbsp;</th><th>状態</th><th>操作</th>
				</tr>
			</thead>
			<tbody>
				<?php if (!empty($info['prove_info']) && is_array($info['prove_info'])): ?>
				<tr class="odd">
					<td width="20%"><strong>状態</strong></td>
					<td style="vertical-align:top">
						<div id="current-prove-mode" style="display:none"></div>
						<table style="width:440px; table-layout:fixed;">
							<tr>
								<td><div>PROVEモード</div></td>
								<td><div id="current-prove-mode-text" style="font-size: 120%;font-weight:bold"></div></td>
							</tr>
							<tr>
								<td><div>Webコンソール<div></td>
								<td><div id="web-console-error" style="font-size: 120%;">Initializing</div></td>
							</tr>
						</table>
					</td>
					<td>
						<span style="font-size: 100%">PROVEモード</span><br />
						<a id="mode-disable" class="control-btn" title="PROVEを無効にします。PHPはPROVEが無い状態で動作します。">PROVE無効</a><br />
						<a id="mode-trace" class="control-btn" title="PROVEによって動作を記録します。リクエストやPHPの動作が全て記録されます。記録したリクエスト情報はバリデーションデータになります。「トレースデータをバリデーションデータにする」をクリックするとトレースデータがバリデーションデータになります。">トレース</a><br />
						<span id="mode-validate"><a href="<?php echo site_url('mode/validate/?redir=start');?>" id="mode-validate-btn" class="control-btn" title="PROVEクライアントからのリクエストを検証するモードに切り替えます。PROVEクライアント以外からのリクエストは無視します。バリデーションモードではPROVEクライアントからのリクエストをトレースデータに保存します。トレースデータを保存したい場合はPROVEクライアントを実行する前に保存してください。「PROVEクライアントを実行する」をクリックするとバリデーションデータを利用して、PROVEクライアントからWebサーバにリクエストが送信され記録されます。その際、差分情報は差分データに記録されます。">バリデーション</a></span><br />
					</td>
				</tr>


				<style type="text/css">
					.meta-cap-width {width:110px; white-space:nowrap; overflow:hidden;}
					.meta-val-width {width:250px; white-space:nowrap; overflow:hidden;}
					.meta-th {background-color:#CCC;}
				</style>
				<tr>
					<td width="20%"><strong>ログ</strong></td>
					<td>
						<table style="width:440px;table-layout:fixed; margin:0 auto 2px auto;">
							<tr>
								<th class="meta-cap-width meta-th">
									<div>トレースログID</div>
								</th>
								<th class="meta-val-width meta-th">
									<div  id="current-trace-log-id" style="float:left;width:0%;text-decoration:underline;cursor:pointer;"></div>
									<div id="current-trace-log-id-remove" style="float:right;width:20px;text-align:right;cursor:pointer">
										<span class="ui-icon ui-icon-trash" style="float:right;margin-right:.3em;"></span>
									</div>
								</th>
							</tr>
							<tr>
								<td class="meta-cap-width">
									<div>データ数</div>
								</td>
								<td class="meta-val-width">
									<div  id="current-trace-log-count">&nbsp;</div>
								</td>
							</tr>
							<tr>
								<td class="meta-cap-width">
									<div>名前</div>
								</td>
								<td class="meta-val-width">
									<div  id="current-trace-log-name">&nbsp;</div>
								</td>
							</tr>
							<tr>
								<td class="meta-cap-width">
									<div>説明</div>
								</td>
								<td class="meta-val-width">
									<div  id="current-trace-log-desc">&nbsp;</div>
								</td>
							</tr>
							<tr>
								<td class="meta-cap-width">
									<div>ロック</div>
								</td>
								<td class="meta-val-width">
									<div  id="current-trace-log-locked">&nbsp;</div>
								</td>
							</tr>
							<tr>
								<td class="meta-cap-width">
									<div>差分取得ログID</div>
								</td>
								<td class="meta-val-width">
									<div  id="current-trace-log-diff-id">&nbsp;</div>
								</td>
							</tr>
						</table>
						<table style="width:440px;table-layout:fixed; margin:0 auto 2px auto;">
							<tr>
								<td class="meta-cap-width meta-th">
									<div>バリデーションログID</div>
								</td>
								<td class="meta-val-width meta-th">
									<div  id="current-validate-log-id" style="float:left;width:0%;text-decoration:underline;cursor:pointer;"></div>
									<div id="current-validate-log-id-remove" style="float:right;width:20px;text-align:right;cursor:pointer">
										<span class="ui-icon ui-icon-trash" style="float:right;margin-right:.3em;"></span>
									</div>
									</div>
								</td>
							</tr>
							<tr>
								<td class="meta-cap-width">
									<div>データ数</div>
								</td>
								<td class="meta-val-width">
									<div  id="current-validate-log-count">&nbsp;</div>
								</td>
							</tr>
							<tr>
								<td class="meta-cap-width">
									<div>名前</div>
								</td>
								<td class="meta-val-width">
									<div  id="current-validate-log-name">&nbsp;</div>
								</td>
							</tr>
							<tr>
								<td class="meta-cap-width">
									<div>説明</div>
								</td>
								<td class="meta-val-width">
									<div  id="current-validate-log-desc" sytle="width:300px;overflow:hidden">&nbsp;</div>
								</td>
							</tr>
							<tr>
								<td class="meta-cap-width">
									<div>ロック</div>
								</td>
								<td class="meta-val-width">
									<div  id="current-validate-log-locked">&nbsp;</div>
								</td>
							</tr>
							<tr>
								<td class="meta-cap-width">
									<div>差分取得ログID</div>
								</td>
								<td class="meta-val-width">
									<div  id="current-validate-log-diff-id">&nbsp;</div>
								</td>
							</tr>
						</table>
						<table style="width:440px;table-layout:fixed; margin:0 auto 2px auto;">
							<tr>
								<td class="meta-cap-width meta-th">
									<div>差分ログID</div>
								</td>
								<td class="meta-val-width meta-th">
									<div  id="current-diff-log-id" style="float:left;width:0%;text-decoration: underline; cursor: pointer;"></div>
									<div id="current-diff-log-id-remove" style="float:right;width:20px;text-align:right;cursor:pointer">
										<span class="ui-icon ui-icon-trash" style="float:right;margin-right:.3em;"></span>
									</div>
								</td>
							</tr>
							<tr>
								<td class="meta-cap-width">
									<div>データ数</div>
								</td>
								<td class="meta-val-width">
									<div  id="current-diff-log-count">&nbsp;</div>
								</td>
							</tr>
							<tr>
								<td class="meta-cap-width">
									<div>名前</div>
								</td>
								<td class="meta-val-width">
									<div  id="current-diff-log-name">&nbsp;</div>
								</td>
							</tr>
							<tr>
								<td class="meta-cap-width">
									<div>説明</div>
								</td>
								<td class="meta-val-width">
									<div  id="current-diff-log-desc">&nbsp;</div>
								</td>
							</tr>
							<tr>
								<td class="meta-cap-width">
									<div>ロック</div>
								</td>
								<td class="meta-val-width">
									<div  id="current-diff-log-locked">&nbsp;</div>
								</td>
							</tr>
							<tr>
								<td class="meta-cap-width">
									<div>差分取得ログID</div>
								</td>
								<td class="meta-val-width">
									<div  id="current-diff-log-diff-id">&nbsp;</div>
								</td>
							</tr>
						</table>
					</td>
					<td>
						<span>ログ操作</span><br />
						<a id="prepare-trace-data-for-validate" class="control-btn" title="トレースログをバリデーション用のデータにします。「PROVEクライアントを実行する」を押すとPROVEクライアントがバリデーションデータから再生したリクエストをWebサーバに送信します。トレースデータ記録時と同じ場合はトレースデータに保存され、差異があるデータは差分データに保存されます。">トレースログ→バリデーションログ</a><br />
						<a id="save-trace-log" class="control-btn" title="トレースログをアーカイブとして保存します。">トレースログをアーカイブ</a><br />
						<a id="save-validate-log" class="control-btn" title="バリデーションログをアーカイブとして保存します。">バリデーションログをアーカイブ</a><br />
						<a id="save-diff-log" class="control-btn" title="差分ログをアーカイブとして保存します。">差分ログをアーカイブ</a><br />
						<br />
						<a id="update-grid" class="control-btn" title="下のPROVEログ一覧を更新します。ログ一覧は負荷軽減の為、自動更新されません。">ログ一覧を更新</a><br />
					</td>
				</tr>



				<tr class="odd">
					<td colspan="3">
						<div id="current-log-id" style="display:none"></div>
						<div id="create-log-dialog" title="Create new log" style="display:none">
							<form id="create-log-form">
								<table style="width: 550px">
									<tr>
										<td>名前</td>
										<td><input type="text" name="name" style="width: 350px" maxlength="64"/></td>
									</tr>
									<tr>
										<td>説明</td>
										<td><input type="text" name="desc" style="width: 350px" maxlength="300"/></td>
									</tr>
									<tr>
										<td colspan="2"><div style="text-align: center">
												<input type="submit" id="create-log-btn" class="control-btn" value="ログを作成" />
										</div></td>
									</tr>
								</table>
							</form>
						</div>

						<div id="edit-log-dialog" title="Edit log" style="display:none">
							<form id="edit-log-form">
								<table style="width: 550px">
									<tr>
										<td>Log ID</td>
										<td><div id="edit-log-id-view"></div></td>
									</tr>
									<tr>
										<td>データ数</td>
										<td><div id="edit-log-count"></div></td>
									</tr>
									<tr>
										<td>名前</td>
										<td><input type="text" id="edit-log-name" name="name" style="width: 350px" maxlength="64"/></td>
									</tr>
									<tr>
										<td>説明</td>
										<td><input type="text" id="edit-log-desc" name="desc" style="width: 350px" maxlength="300"/></td>
									</tr>
									<tr>
										<td>ロック</td>
										<td><div style="text-align: left">
												<input type="checkbox" id="edit-log-locked" name="locked" style="width: 350px"/>
										</div></td>
									</tr>
									<tr>
										<td>差分ID</td>
										<td><input type="text" id="edit-log-diff-id" name="diff_id" style="width: 350px" maxlength="300"/></td>
									</tr>
									<tr>
										<td colspan="2"><div style="text-align: center">
												<input type="submit" id="edit-log-btn" class="control-btn" value="変更を保存" />
										</div></td>
									</tr>
								</table>
								<input type="hidden" id="edit-log-id" name="id" />
							</form>
						</div>

						<div id="remove-log-dialog" title="Delete log" style="display:none">
							<form id="remove-log-form">
								<table style="width: 550px">
									<tr>
										<td>Log ID</td><td><div id="remove-log-id"></div></td>
									</tr>
									<tr>
										<td>名前</td><td><div id="remove-log-name"></div></td>
									</tr>
									<tr>
										<td>説明</td><td><div id="remove-log-desc"></div></td>
									</tr>
									<tr>
										<td>ロック</td><td><div id="remove-log-locked"></div></td>
									</tr>
									<tr>
										<td>差分ログID</td><td><div id="remove-log-diff-id"></div></td>
									</tr>
									<tr>
										<td colspan="2"><div style="text-align: center"><input type="submit" id="remove-log-btn" class="control-btn" value="ログを削除" /></div></td>
									</tr>
								</table>
							</form>
						</div>

						<div class="contextMenu" id="log-menu" style="display:none">
							<ul style="width: 350px">
								<li id="create">
									<span class="ui-icon ui-icon-plus" style="float:left"></span>
									<span style="font-size:11px; font-family:Verdana">Create Log</span>
								</li>
								<li id="edit">
									<span class="ui-icon ui-icon-pencil" style="float:left"></span>
									<span style="font-size:11px; font-family:Verdana">Edit Log</span>
								</li>
								<li id="remove">
									<span class="ui-icon ui-icon-trash" style="float:left"></span>
									<span style="font-size:11px; font-family:Verdana">Remove Log</span>
								</li>
								<li id="prepare-trace">
									<span class="ui-icon " style="float:left"></span>
									<span style="font-size:11px; font-family:Verdana">Trace</span>
								</li>
								<li id="prepare-validate">
									<span class="ui-icon " style="float:left"></span>
									<span style="font-size:11px; font-family:Verdana">Validate</span>
								</li>
								<li id="prepare-diff">
									<span class="ui-icon " style="float:left"></span>
									<span style="font-size:11px; font-family:Verdana">Diff</span>
								</li>
							</ul>
						</div>

						<div id="prove-num-logs" style="display:none"></div>
						<div id="prove-log-grid-container" class="ui-jqgrid" style="width:917px" >
							<div id="resperror"></div>
							<table id="prove-log-grid"></table>
							<div id="prove-log-grid-pager"></div>
						</div>

					</td>
				</tr>



				<tr>
					<td width="20%"><strong>クライアント</strong></td>
					<td>
						<div id="client-status" style="font-size: 120%"></div>
						<span id="client-log-cap"> PROVEクライントログ</span>
						<pre><div id="client-log" style="width: 440px; height: 250px; font-size: 100%;overflow-x: scroll; overflow-y: scroll ;border-style: solid;border-width: 1px; border-color: #CCCCCC;"></div></pre>
					</td>
					<td>
						<span>PROVEクライアント操作</span><br />
						<a id="validate-start" class="control-btn" title="PROVEクライアントを実行してバリデーションを開始します。トレースデータがロックされている場合は自動的にアンロックします。差異の無いデータはトレースデータに保存され、差異があるデータは差分データに保存されます。">PROVEクライアント実行</a><br />
						<a id="validate-stop" class="control-btn" title="実行中のPROVEクライアントを強制的に停止します。PROVEクライアントの実行を中止したい場合に利用します。">PROVEクライアント実行中止</a><br />
					</td>
				</tr>
				<tr class="odd">
					<td width="20%"><strong>その他の操作</strong></td>
					<td>
						<span style="font-size: 150%">ツール</span><br />
						<span id="web-shell"><a href="#web-shell" class="control-btn" title="接続中のWebサーバのシェルを起動します。Webサーバ権限でアクセスするのでPROVEのログファイルなどの操作が可能です。">Webサーバのシェル</a></span><br />
						<span id="web-shell"><a href="<?php echo base_url().'nav-php-logs/'?>" target="NAV_PHP" class="control-btn" title="接続中のWebサーバのログディレクトリのファイルにアクセスします。">WebサーバのProveログ</a></span><br />
						<span id="web-shell"><a href="<?php echo base_url().'nav-php-docs/'?>" target="NAV_PHP" class="control-btn" title="接続中のWebサーバのドキュメントルートの１つ上のディレクトリにアクセスします。">Webサーバのスクリプト</a></span><br />
					</td>
					<td>
					</td>
				</tr>
				<?php else: ?>
				<tr colspan="2"><td>PROVE情報が取得できませんでした。</td></tr>
				<?php endif; ?>
			</tbody>
		</table>
		<div class="mg_bottom"></div>
	</div>
</div>

<div class="mg_line02"><h3 onclick="$('#prove-news').toggle('slow');">PROVEPHP.COMからのお知らせ</h3></div>
<div id="prove-news" class="mg_content">
	<div class="mg_back">
		<div class="mg_header"></div>
		<table>
			<thead>
				<tr>
					<th>新着情報</th>
				</tr>
			</thead>
			<tbody>
				<?php if (!empty($info['prove_news'])): ?>
				<tr class="odd">
					<td><?php echo $info['prove_news'] ?></td>
				</tr>
				<?php else: ?>
				<tr class="odd"><td>お知らせが取得できませんでした。</td></tr>
				<?php endif; ?>
			</tbody>
		</table>
		<div class="mg_bottom"></div>
	</div>
</div>

<div class="mg_line02"><h3 onclick="$('#prove-status').toggle('slow');">PROVEの状態</h3></div>
<div id="prove-status" style="display: none" class="mg_content">
	<div class="mg_back">
		<div class="mg_header"></div>
		<table>
			<thead>
				<tr>
					<th>項目</th><th>値</th>
				</tr>
			</thead>
			<tbody>
				<?php if (!empty($info['prove_info']) && is_array($info['prove_info'])): ?>
				<tr class="odd">
					<td width="20%">ファイルシステム<br />(<?php echo h($info['prove_info']['prove_dir']) ?>)</td><td><?php echo h($info['fs_type']) ?></p>
</td>
				</tr>
				<tr>
					<td width="20%">ファイルシステム空き容量<br />(<?php echo h($info['prove_info']['prove_dir']) ?>)</td><td><?php echo h($info['prove_free']) ?>/<?php echo h($info['prove_total']) ?> (<?php printf("%02d", $info['prove_free']*100/$info['prove_total']) ?>%)</td>
				</tr>
				<tr class="odd">
					<td width="20%">トレースレコード数<br />(<?php echo h($info['trace_dir']) ?>)</td><td><?php echo h($info['trace_record']) ?></td>
				</tr>
				<tr>
					<td width="20%">バリデーションレコード数<br />(<?php echo h($info['validate_dir']) ?>)</td><td><?php echo h($info['validate_record']) ?></td>
		</tr>
				<tr class="odd">
			<td width="20%">差分レコード数<br />(<?php echo h($info['diff_dir']) ?>)</td><td><?php echo h($info['diff_record']) ?></td>
				</tr>
				<tr>
					<td width="20%"><?php echo h($info['prove_info']['prove_dir']) ?> の内容</td><td><pre><?php echo h($info['prove_dir']) ?></pre></td>
				</tr>
				<?php else: ?>
				<tr colspan="2"><td>PROVE情報が取得できませんでした。</td></tr>
				<?php endif; ?>
			</tbody>
		</table>
		<div class="mg_bottom"></div>
	</div>
</div>


<div class="mg_line02"><h3 onclick="$('#prove-info').toggle('slow')" >prove_info()の内容</h3></div>
<div id="prove-info" style="display: none" class="mg_content">
	<div class="mg_back">
		<div class="mg_header"></div>
		<table>
			<thead>
				<tr>
					<th>項目</th><th>値</th>
				</tr>
			</thead>
			<tbody>
				<?php
		 if (!empty($info['prove_info']) && is_array($info['prove_info'])) { 
				 $i = 0;
				 foreach($info['prove_info'] as $key => $value) {
						 if ($i++%2) {
								 echo '<tr class="odd"><td width="20%">', h($key), '</td><td>', is_array($value) ? h(join(' ', $value)) : h($value),'</td></tr>',PHP_EOL;
						 } else {
								 echo '<tr><td width="20%">', h($key), '</td><td>', is_array($value) ? h(join(' ', $value)) : h($value),'</td></tr>', PHP_EOL;
						 }
				 }
		 } else {
				 echo '<tr colspan="2"><td>PROVE情報が取得できませんでした。</td></tr>'.PHP_EOL;
		 }
				?>
			</tbody>
		</table>
		<div class="mg_bottom"></div>
	</div>
</div>

<div id="web-shell-dialog" title="Remote Server Shell" style="width: 80%; height: 550px">
		<p style="text-align: center">注意：接続中のWebサーバのシェルです！ファイル削除などは慎重に行なってください。仕様としてエラーメッセージは表示されません。</p>
		<div id="web-shell-dialog-content" style="width:100%; height:100%; overflow: hidden">
		</div>
</div>


<!-- END status/system.php -->
